// from http://math.uchicago.edu/~cstaats/Notes_and_papers_files/asymptote_tutorial.pdf
settings.outformat = "pdf";
settings.prc = false;
// the original - needs freeglut
//settings.render=4;
// but use this is freeglut is not present
settings.render=0;
size(17cm,0);
import graph3;
currentprojection =
perspective(10,5,-8);
path center_path = (0,0) --- (0,3)
.. (1.5,3) .. (0,0.3) --- (0,0);
real bottomradius = 0.6;
real topradius = 0.1;

path radius_graph = (0,bottomradius) {up} ::
    (0.3,1.2*bottomradius) --- (0.6, 1.2*bottomradius) ::
    (1.2,topradius) --- (2,topradius) :: {up} (3,bottomradius);

radius_graph = xscale(1/3) * radius_graph;
radius_graph = (shift(-1,0)*radius_graph) & radius_graph &
    (shift(1,0)*radius_graph);

real radius(real t) {
  return point(radius_graph, times(radius_graph, t)[0]).y;
}

triple F(pair w) {
  real t = w.x % 2.0;
  bool reverse = (t >= 1.0);
  t %= 1.0;

  real relt = reltime(center_path, t);
  real theta = w.y;
  triple center = YZplane(point(center_path, relt));
  pair tangent = dir(center_path, relt);
  if (reverse) tangent *= -1;
  triple normal = X;
  triple binormal = cross(YZplane(tangent), normal);
  triple v = normal*cos(theta) + binormal*sin(theta);
  return center + radius(t)*v;
}

surface kleinbottle = surface(F, (0.5,0), (1.5, 2pi), nu=32,
    nv=16, Spline);

draw(kleinbottle, white);

