// The final example from https://tug.org/TUGboat/tb33-2/tb104doob.pdf
// Approaching Asymptote - Michael Doob and Jim Hefferon
// TUGboat, Volume 33 (2012), No. 2.
// Severely altered to see how things turn out, and with added unitbox
// Which turns out not to be where I expected it to be.  For amusement.

//size(3inch);
size(8cm);
import settings; settings.render=10;
settings.outformat="html";
import graph3;
currentprojection=perspective(2,4,1);
currentlight=(5,4,4);
real pi=2*acos(0);
path3 P=(-1,-1,0)--(-1,1,0)--(1,1,0)--(1,-1,0)--cycle;
// with nolight, solid fuchsia whatever the orientation
// with currentlight it gets darker when shaded
//draw(surface(P),fuchsia,nolight);
draw(surface(P),fuchsia,currentlight);

real f(pair z){return 0.9+sin(z.x*1.2*pi)*sin(z.y*0.9*pi);}
draw(surface(f,(-1,-1),(1,1),nx=100), royalblue);

// default for a pen is roundcap
pen axispen=(linewidth(1.5)+squarecap);
pen axispen=(linewidth(1.5)+cyan);
axes3((-1.1,-1.3,-0.5),(1.1,1.1,2.2),axispen);

// add cube based on doc/cube.asy in asy sources
draw(unitbox);

dot(unitbox,red);

label("$O$",(0,0,0),NW);
label("(1,0,0)",(1,0,0),S);
label("(0,1,0)",(0,1,0),E);
label("(0,0,1)",(0,0,1),Z);

